// --------------------------------------------------------------------
// Author  : mashimonator
// Create  : 2009/11/12
// Update  : 2009/11/12
// Description : フォームのパスワード入力支援
// --------------------------------------------------------------------

/*@cc_on 
var doc = document;
eval('var document = doc');
@*/
var passwordTextExtension = {
	//-----------------------------------------
	// 設定値
	//-----------------------------------------
	conf : {
		targetClass : 'pwdExt', // 対象とするクラス
		speed : 70, // 文字を隠す速さ
		tooltipColor : 'black' // tooltipの色 --> 'black','white','red','green'
	},
	storage : {
		target : null,
		checkTimer : null,
		hideTimer : null,
		tooltip : null,
		content : null,
		shim : null
	},
	//-----------------------------------------
	// 初期処理
	//-----------------------------------------
	init : function() {
		var ipts = passwordTextExtension.getTargetElements( 'input', passwordTextExtension.conf.targetClass );
		for ( var i = 0, len = ipts.length; i < len; i++ ) {
			if ( ipts[i].type.toLowerCase() == 'password' ) {
				// イベントに関数を付加
				passwordTextExtension.addEvent( ipts[i], 'focus', passwordTextExtension.focus );
				passwordTextExtension.addEvent( ipts[i], 'blur', passwordTextExtension.blur );
			}
		}
		// tooltip生成
		passwordTextExtension.createTooltip();
		// shimを生成
		passwordTextExtension.storage.shim = passwordTextExtension.createShim();
	},
	//-----------------------------------------
	// tooltipを生成する
	//-----------------------------------------
	createTooltip : function() {
		// tooltip生成
		var parentDiv = document.createElement('div');
		switch (passwordTextExtension.conf.tooltipColor) {
			case 'black':
				parentDiv.className = 'passwordTooltip blackTooltip';
				break;
			case 'white':
				parentDiv.className = 'passwordTooltip whiteTooltip';
				break;
			case 'red':
				parentDiv.className = 'passwordTooltip redTooltip';
				break;
			case 'green':
				parentDiv.className = 'passwordTooltip greenTooltip';
				break;
			default:
				parentDiv.className = 'passwordTooltip blackTooltip';
				break;
		}
		parentDiv.style.zIndex = '200';
		parentDiv.style.visibility = 'hidden';
		document.body.appendChild(parentDiv);
		// content生成
		var contentDiv = document.createElement('div');
		contentDiv.className = 'passwordTooltipContent';
		contentDiv.innerHTML = String.fromCharCode(8203);
		parentDiv.appendChild(contentDiv);
		// arrow生成
		var arrowDiv = document.createElement('div');
		arrowDiv.style.zIndex = '201';
		arrowDiv.className = 'passwordTooltipArrow';
		for (var i = 10; i > 0; i--) {
			var lineDiv = document.createElement('div');
			lineDiv.className = 'passwordLine' + i;
			lineDiv.innerHTML = String.fromCharCode(8203);
			arrowDiv.appendChild(lineDiv);
		}
		parentDiv.appendChild(arrowDiv);
		// 初期位置セット
		passwordTextExtension.setPosition(parentDiv, 0, 0);
		// 保持
		passwordTextExtension.storage.tooltip = parentDiv;
		passwordTextExtension.storage.content = contentDiv;
	},
	//-----------------------------------------
	// shimを生成する
	//-----------------------------------------
	createShim : function() {
		// iframe要素を生成
		var iframe = document.createElement('iframe');
		// スタイルをセット
		iframe.setAttribute('frameBorder', '0');
		iframe.setAttribute('scrolling', 'no');
		iframe.style.border = 'none';
		iframe.style.zIndex = '150';
		passwordTextExtension.setSize( iframe, 1, 1 );
		iframe.style.visibility = 'hidden';
		// 要素を追加
		document.body.appendChild(iframe);
		return iframe;
	},
	//-----------------------------------------
	// shimのスタイルをリセットする
	//-----------------------------------------
	resetShim : function() {
		passwordTextExtension.setSize( passwordTextExtension.storage.shim, 1, 1 );
		passwordTextExtension.setPosition( passwordTextExtension.storage.shim, 0, 0 );
		passwordTextExtension.storage.shim.style.visibility = 'hidden';
	},
	//-----------------------------------------
	// focusイベントでの処理
	//-----------------------------------------
	focus : function() {
		// 入力中のinput要素を取得
		passwordTextExtension.storage.target = document.getElementById(this.id);
		// ポジション取得
		var pos = passwordTextExtension.getElementPosition(passwordTextExtension.storage.target);
		// サイズ取得
		var size = passwordTextExtension.getElementSize(passwordTextExtension.storage.target);
		var tooltipSize = passwordTextExtension.getElementSize(passwordTextExtension.storage.tooltip);
		// パスワード表示エリアの位置をセット
		passwordTextExtension.setPosition(passwordTextExtension.storage.tooltip, pos.top - tooltipSize.height, pos.left);
		// shimの位置をセット
		passwordTextExtension.setPosition(passwordTextExtension.storage.shim, pos.top - tooltipSize.height, pos.left);
		// Timerスタート
		passwordTextExtension.storage.checkTimer = window.setTimeout('passwordTextExtension.checkPassword(\'\')', 200);
	},
	//-----------------------------------------
	// blurイベントでの処理
	//-----------------------------------------
	blur : function() {
		// Timerストップ
		window.clearTimeout(passwordTextExtension.storage.checkTimer);
		passwordTextExtension.storage.checkTimer = null;
		// 入力中のinput要素をクリア
		passwordTextExtension.storage.target = null;
		// パスワード表示エリアを非表示
		passwordTextExtension.setOpacity( passwordTextExtension.storage.tooltip, 0 );
		// shimをリセット
		passwordTextExtension.resetShim();
	},
	//-----------------------------------------
	// 入力値のチェック処理
	//-----------------------------------------
	checkPassword : function( oldStr ) {
		var newStr = passwordTextExtension.storage.target.value;
		if ( newStr != '' && newStr != oldStr ) {
			// 入力値をセット
			passwordTextExtension.storage.content.innerHTML = newStr;
			// タイマークリア
			window.clearTimeout(passwordTextExtension.storage.hideTimer);
			passwordTextExtension.storage.hideTimer = null;
			// shimのサイズ設定
			var size = passwordTextExtension.getElementSize(passwordTextExtension.storage.tooltip);
			passwordTextExtension.setSize( passwordTextExtension.storage.shim, size.width, size.height );
			// shimを表示
			passwordTextExtension.storage.shim.style.visibility = 'visible';
			// パス表示エリアを表示
			passwordTextExtension.storage.tooltip.style.visibility = 'visible';
			passwordTextExtension.setOpacity( passwordTextExtension.storage.tooltip, 10 );
			// 非表示処理開始
			passwordTextExtension.hide();
		}
		passwordTextExtension.storage.checkTimer = window.setTimeout('passwordTextExtension.checkPassword(\'' + newStr + '\')', 200);
	},
	//-----------------------------------------
	// 対象要素の非表示処理
	//-----------------------------------------
	hide : function( id ) {
		var opacity = passwordTextExtension.getOpacity( passwordTextExtension.storage.tooltip );
		if ( opacity > 0 ) {
			// 不透明度をセット
			passwordTextExtension.setOpacity( passwordTextExtension.storage.tooltip, opacity-1 );
			// タイマーセット
			passwordTextExtension.storage.hideTimer = window.setTimeout('passwordTextExtension.hide()', passwordTextExtension.conf.speed);
		} else {
			// パスワード表示エリアを非表示
			passwordTextExtension.storage.tooltip.style.visibility = 'hidden';
			// shimを非表示
			passwordTextExtension.storage.shim.style.visibility = 'hidden';
			// タイマークリア
			window.clearTimeout(passwordTextExtension.storage.hideTimer);
			passwordTextExtension.storage.hideTimer = null;
		}
	},
	//-----------------------------------------
	// 要素の不透明度を取得する
	//-----------------------------------------
	getOpacity : function( element ) {
		if ( element.alpha ) {
				return element.alpha / 10;
		} else if ( element.style ) {
			if ( element.style.opacity ) {
				return element.style.opacity * 10;
			}
		} 
		return 0;
	},
	//-----------------------------------------
	// 要素の不透明度を設定する
	//-----------------------------------------
	setOpacity : function( element, val ) {
		element.style.opacity = val / 10;
		element.style.filter = 'alpha(opacity=' + val * 10 + ')';
		element.alpha = val * 10;
	},
	//-----------------------------------------
	// 要素のサイズを設定する
	//-----------------------------------------
	setSize : function( element, width, height ) {
		element.style.width = width + 'px';
		element.style.height = height + 'px';
	},
	//-----------------------------------------
	// 要素の位置を設定する
	//-----------------------------------------
	setPosition : function( element, top, left ) {
		element.style.position = 'absolute';
		element.style.top = top + 'px';
		element.style.left = left + 'px';
	},
	//-----------------------------------------
	// 対象要素のポジションを取得する
	//-----------------------------------------
	getElementPosition : function( element ) {
		var offsetTrail = (typeof element == 'string') ? document.getElementById(element): element;
		var x = 0;
		var y = 0;
		while (offsetTrail) {
			x += offsetTrail.offsetLeft;
			y += offsetTrail.offsetTop;
			offsetTrail = offsetTrail.offsetParent;
		}
		if ( navigator.userAgent.indexOf('Mac') != -1 && typeof doc.body.leftMargin != 'undefined' ) {
			x += document.body.leftMargin;
			y += document.body.topMargin;
		}
		return ({ 'left': x, 'top': y });
	},
	//-----------------------------------------
	// 対象要素のサイズを取得する
	//-----------------------------------------
	getElementSize : function( element ) {
		var w = element.offsetWidth;
		var h = element.offsetHeight;
		return ({ 'width': w, 'height': h });
	},
	//-----------------------------------------
	// ターゲットタグを取得する
	//-----------------------------------------
	getTargetElements : function( tag, cls ) {
		var elements = new Array();
		var targetElements = document.getElementsByTagName(tag.toUpperCase());
		for ( var i = 0, len = targetElements.length; i < len; i++ ) {
			if ( targetElements[i].className.match(cls) ) {
				elements[elements.length] = targetElements[i];
			}
		}
		return elements;
	},
	//-----------------------------------------
	// イベントに関数を付加する
	//-----------------------------------------
	addEvent : function( target, event, func ) {
		try {
			target.addEventListener(event, func, false);
		} catch (e) {
			target.attachEvent('on' + event, (function(el){return function(){func.call(el);};})(target));
		}
	}
}
// 実行
passwordTextExtension.addEvent( window, 'load', passwordTextExtension.init );